<script lang="ts">
  import { requireAuth, requireEventStarted } from "@auth/PermissionRequired";
  import { team, eventId } from "@stores";
  import { Alert, ListGroup, ListGroupItem, Spinner } from "@sveltestrap/sveltestrap";
  import { goto } from "$app/navigation";
  import oidc from "@auth/keycloak";
  import { TeamListStore, type TeamList$result } from "$houdini";

  const ready = Promise.all([requireEventStarted(), requireAuth()]);

  async function navigate(): Promise<TeamList$result['teams']> {
    await ready;

    if (!oidc.isStaff()) {
      if ($team?.id) await goto(`/teams/${$team.id}`);
      else throw new Error("Your team was not found!");
    }

    const teams = new TeamListStore();
    return (await teams.fetch({
      variables: { eventId: $eventId }
    })).data?.teams || [];
  }
</script>

<svelte:head>
  <title>My Team</title>
</svelte:head>

<div class="container d-flex mt-3">
  {#await navigate()}
    <div class="m-auto d-flex flex-column">
      Loading...
      <br />
      <Spinner class="mt-2 mx-auto" />
    </div>
  {:then teams}
    <ListGroup class="mx-auto ">
      {#each teams as team}
        <ListGroupItem class="hover" href="/teams/{team.id}">{team.name} - {team.long_name}</ListGroupItem>
      {/each}
    </ListGroup>
  {:catch err}
    <Alert class="flex-grow-1" color="danger">{err}</Alert>
  {/await}
</div>
